// Postprocess hypno overlay | Fragment
// drewcification 022521
#version 130

// These 3 are required by the filter manager to be present
uniform sampler2D color_texture;
uniform sampler2D depth_texture;
uniform vec2 resolution;

uniform float osg_FrameTime;

in vec2 texcoord;
out vec4 color;

// Adjust Saturation formula
vec3 adjustSaturation(vec3 color, float adjustment)
{
    const vec3 W = vec3(0.2125, 0.7154, 0.0721);
    vec3 intensity = vec3(dot(color, W));
    return mix(intensity, color, adjustment);
}
void main() {
	color = texture(color_texture, texcoord);
	
	// Run the saturation adjust formula
	color = vec4(adjustSaturation(color.rgb, 0.0), color.a);
		
	vec2 uv = (gl_FragCoord.xy - 0.5 * resolution.xy) / resolution.y;

    float distance = length(uv);

    float angle = atan(uv.y, uv.x);
	float r = sin(distance * 200.0 + angle + osg_FrameTime);
    r+= sin(distance * 200.0 + angle + osg_FrameTime + (1.0 / 4.0) * 6.2831853)-0.2;
	float g = 1.0;
	if (r > 0.5){
		g = 0.7;
		r = 0.0;}
    color *= vec4(r, g, r, 1.0);

}
